warn if keyserver query fails (Closes: MS #1750)
[monkeysphere.git] / src / share / common
1 # -*-shell-script-*-
2 # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
3
4 # Shared sh functions for the monkeysphere
5 #
6 # Written by
7 # Jameson Rollins <jrollins@finestructure.net>
8 # Jamie McClelland <jm@mayfirst.org>
9 # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
10 #
11 # Copyright 2008-2009, released under the GPL, version 3 or later
12
13 # all-caps variables are meant to be user supplied (ie. from config
14 # file) and are considered global
15
16 ########################################################################
17 ### UTILITY FUNCTIONS
18
19 # output version info
20 version() {
21     cat "${SYSSHAREDIR}/VERSION"
22 }
23
24 # failure function.  exits with code 255, unless specified otherwise.
25 failure() {
26     [ "$1" ] && echo "$1" >&2
27     exit ${2:-'255'}
28 }
29
30 # write output to stderr based on specified LOG_LEVEL the first
31 # parameter is the priority of the output, and everything else is what
32 # is echoed to stderr.  If there is nothing else, then output comes
33 # from stdin, and is not prefaced by log prefix.
34 log() {
35     local priority
36     local level
37     local output
38     local alllevels
39     local found=
40
41     # don't include SILENT in alllevels: it's handled separately
42     # list in decreasing verbosity (all caps).
43     # separate with $IFS explicitly, since we do some fancy footwork
44     # elsewhere.
45     alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
46
47     # translate lowers to uppers in global log level
48     LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
49
50     # just go ahead and return if the log level is silent
51     if [ "$LOG_LEVEL" = 'SILENT' ] ; then
52         return
53     fi
54
55     for level in $alllevels ; do 
56         if [ "$LOG_LEVEL" = "$level" ] ; then
57             found=true
58         fi
59     done
60     if [ -z "$found" ] ; then
61         # default to INFO:
62         LOG_LEVEL=INFO
63     fi
64
65     # get priority from first parameter, translating all lower to
66     # uppers
67     priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
68     shift
69
70     # scan over available levels
71     for level in $alllevels ; do
72         # output if the log level matches, set output to true
73         # this will output for all subsequent loops as well.
74         if [ "$LOG_LEVEL" = "$level" ] ; then
75             output=true
76         fi
77         if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
78             if [ "$1" ] ; then
79                 echo "$@"
80             else
81                 cat
82             fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
83         fi
84     done
85 }
86
87 # run command as monkeysphere user
88 su_monkeysphere_user() {
89     # our main goal here is to run the given command as the the
90     # monkeysphere user, but without prompting for any sort of
91     # authentication.  If this is not possible, we should just fail.
92
93     # FIXME: our current implementation is overly restrictive, because
94     # there may be some su PAM configurations that would allow su
95     # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
96     # allowing specific users to invoke commands which make use of
97     # this user.
98
99     # chpst (from runit) would be nice to use, but we don't want to
100     # introduce an extra dependency just for this.  This may be a
101     # candidate for re-factoring if we switch implementation languages.
102
103     case $(id -un) in
104         # if monkeysphere user, run the command under bash
105         "$MONKEYSPHERE_USER")
106             bash -c "$@"
107             ;;
108
109          # if root, su command as monkeysphere user
110         'root')
111             su "$MONKEYSPHERE_USER" -c "$@"
112             ;;
113
114         # otherwise, fail
115         *)
116             log error "non-privileged user."
117             ;;
118     esac
119 }
120
121 # cut out all comments(#) and blank lines from standard input
122 meat() {
123     grep -v -e "^[[:space:]]*#" -e '^$' "$1"
124 }
125
126 # cut a specified line from standard input
127 cutline() {
128     head --line="$1" "$2" | tail -1
129 }
130
131 # make a temporary directory
132 msmktempdir() {
133     mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
134 }
135
136 # make a temporary file
137 msmktempfile() {
138     mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
139 }
140
141 # this is a wrapper for doing lock functions.
142 #
143 # it lets us depend on either lockfile-progs (preferred) or procmail's
144 # lockfile, and should
145 lock() {
146     local use_lockfileprogs=true
147     local action="$1"
148     local file="$2"
149
150     if ! ( type lockfile-create &>/dev/null ) ; then
151         if ! ( type lockfile &>/dev/null ); then
152             failure "Neither lockfile-create nor lockfile are in the path!"
153         fi
154         use_lockfileprogs=
155     fi
156     
157     case "$action" in
158         create)
159             if [ -n "$use_lockfileprogs" ] ; then
160                 lockfile-create "$file" || failure "unable to lock '$file'"
161             else
162                 lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
163             fi
164             log debug "lock created on '$file'."
165             ;;
166         touch)  
167             if [ -n "$use_lockfileprogs" ] ; then
168                 lockfile-touch --oneshot "$file"
169             else
170                 : Nothing to do here
171             fi
172             log debug "lock touched on '$file'."
173             ;;
174         remove)
175             if [ -n "$use_lockfileprogs" ] ; then
176                 lockfile-remove "$file"
177             else
178                 rm -f "${file}.lock"
179             fi
180             log debug "lock removed on '$file'."
181             ;;
182         *)
183             failure "bad argument for lock subfunction '$action'"
184     esac
185 }
186
187
188 # for portability, between gnu date and BSD date.
189 # arguments should be:  number longunits format
190
191 # e.g. advance_date 20 seconds +%F
192 advance_date() {
193     local gnutry
194     local number="$1"
195     local longunits="$2"
196     local format="$3"
197     local shortunits
198
199     # try things the GNU way first 
200     if date -d "$number $longunits" "$format" &>/dev/null; then
201         date -d "$number $longunits" "$format"
202     else
203         # otherwise, convert to (a limited version of) BSD date syntax:
204         case "$longunits" in
205             years)
206                 shortunits=y
207                 ;;
208             months)
209                 shortunits=m
210                 ;;
211             weeks)
212                 shortunits=w
213                 ;;
214             days)
215                 shortunits=d
216                 ;;
217             hours)
218                 shortunits=H
219                 ;;
220             minutes)
221                 shortunits=M
222                 ;;
223             seconds)
224                 shortunits=S
225                 ;;
226             *)
227                 # this is a longshot, and will likely fail; oh well.
228                 shortunits="$longunits"
229         esac
230         date "-v+${number}${shortunits}" "$format"
231     fi
232 }
233
234
235 # check that characters are in a string (in an AND fashion).
236 # used for checking key capability
237 # check_capability capability a [b...]
238 check_capability() {
239     local usage
240     local capcheck
241
242     usage="$1"
243     shift 1
244
245     for capcheck ; do
246         if echo "$usage" | grep -q -v "$capcheck" ; then
247             return 1
248         fi
249     done
250     return 0
251 }
252
253 # hash of a file
254 file_hash() {
255     if type md5sum &>/dev/null ; then
256         md5sum "$1"
257     elif type md5 &>/dev/null ; then
258         md5 "$1"
259     else
260         failure "Neither md5sum nor md5 are in the path!"
261     fi
262 }
263
264 # convert escaped characters in pipeline from gpg output back into
265 # original character
266 # FIXME: undo all escape character translation in with-colons gpg
267 # output
268 gpg_unescape() {
269     sed 's/\\x3a/:/g'
270 }
271
272 # convert nasty chars into gpg-friendly form in pipeline
273 # FIXME: escape everything, not just colons!
274 gpg_escape() {
275     sed 's/:/\\x3a/g'
276 }
277
278 # prompt for GPG-formatted expiration, and emit result on stdout
279 get_gpg_expiration() {
280     local keyExpire
281
282     keyExpire="$1"
283
284     if [ -z "$keyExpire" -a "$PROMPT" != 'false' ]; then
285         cat >&2 <<EOF
286 Please specify how long the key should be valid.
287          0 = key does not expire
288       <n>  = key expires in n days
289       <n>w = key expires in n weeks
290       <n>m = key expires in n months
291       <n>y = key expires in n years
292 EOF
293         while [ -z "$keyExpire" ] ; do
294             printf "Key is valid for? (0) " >&2
295             read keyExpire
296             if ! test_gpg_expire ${keyExpire:=0} ; then
297                 echo "invalid value" >&2
298                 unset keyExpire
299             fi
300         done
301     elif ! test_gpg_expire "$keyExpire" ; then
302         failure "invalid key expiration value '$keyExpire'."
303     fi
304         
305     echo "$keyExpire"
306 }
307
308 passphrase_prompt() {
309     local prompt="$1"
310     local fifo="$2"
311     local PASS
312
313     if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null 2>/dev/null; then
314         printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
315         printf '(with prompt "%s")\n' "$prompt" | log debug
316         "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
317     else
318         read -s -p "$prompt" PASS
319         # Uses the builtin echo, so should not put the passphrase into
320         # the process table.  I think. --dkg
321         echo "$PASS" > "$fifo"
322     fi
323 }
324
325 # remove all lines with specified string from specified file
326 remove_line() {
327     local file
328     local string
329     local tempfile
330
331     file="$1"
332     string="$2"
333
334     if [ -z "$file" -o -z "$string" ] ; then
335         return 1
336     fi
337
338     if [ ! -e "$file" ] ; then
339         return 1
340     fi
341
342     # if the string is in the file...
343     if grep -q -F "$string" "$file" 2>/dev/null ; then
344         tempfile=$(mktemp "${file}.XXXXXXX") || \
345             failure "Unable to make temp file '${file}.XXXXXXX'"
346         
347         # remove the line with the string, and return 0
348         grep -v -F "$string" "$file" >"$tempfile"
349         cat "$tempfile" > "$file"
350         rm "$tempfile"
351         return 0
352     # otherwise return 1
353     else
354         return 1
355     fi
356 }
357
358 # remove all lines with MonkeySphere strings in file
359 remove_monkeysphere_lines() {
360     local file
361     local tempfile
362
363     file="$1"
364
365     # return error if file does not exist
366     if [ ! -e "$file" ] ; then
367         return 1
368     fi
369
370     # just return ok if the file is empty, since there aren't any
371     # lines to remove
372     if [ ! -s "$file" ] ; then
373         return 0
374     fi
375
376     tempfile=$(mktemp "${file}.XXXXXXX") || \
377         failure "Could not make temporary file '${file}.XXXXXXX'."
378
379     egrep -v '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$' \
380         "$file" >"$tempfile"
381     cat "$tempfile" > "$file"
382     rm "$tempfile"
383 }
384
385 # translate ssh-style path variables %h and %u
386 translate_ssh_variables() {
387     local uname
388     local home
389
390     uname="$1"
391     path="$2"
392
393     # get the user's home directory
394     userHome=$(get_homedir "$uname")
395
396     # translate '%u' to user name
397     path=${path/\%u/"$uname"}
398     # translate '%h' to user home directory
399     path=${path/\%h/"$userHome"}
400
401     echo "$path"
402 }
403
404 # test that a string to conforms to GPG's expiration format
405 test_gpg_expire() {
406     echo "$1" | egrep -q "^[0-9]+[mwy]?$"
407 }
408
409 # check that a file is properly owned, and that all it's parent
410 # directories are not group/other writable
411 check_key_file_permissions() {
412     local uname
413     local path
414
415     uname="$1"
416     path="$2"
417
418     if [ "$STRICT_MODES" = 'false' ] ; then
419         log debug "skipping path permission check for '$path' because STRICT_MODES is false..."
420         return 0
421     fi
422     log debug "checking path permission '$path'..."
423     "${SYSSHAREDIR}/checkperms" "$uname" "$path"
424 }
425
426 # return a list of all users on the system
427 list_users() {
428     if type getent &>/dev/null ; then
429         # for linux and FreeBSD systems
430         getent passwd | cut -d: -f1
431     elif type dscl &>/dev/null ; then
432         # for Darwin systems
433         dscl localhost -list /Search/Users
434     else
435         failure "Neither getent or dscl is in the path!  Could not determine list of users."
436     fi
437 }
438
439 # take one argument, a service name.  in response, print a series of
440 # lines, each with a unique numeric port number that might be
441 # associated with that service name.  (e.g. in: "https", out: "443")
442 # if nothing is found, print nothing, and return 0.
443
444 # return 1 if there was an error in the search somehow
445 get_port_for_service() {
446
447     [[ "$1" =~ ^[a-z0-9]([a-z0-9-]*[a-z0-9])?$ ]] || \
448         failure $(printf "This is not a valid service name: '%s'" "$1")
449     if type getent &>/dev/null ; then
450         # for linux and FreeBSD systems (getent returns 2 if not found, 0 on success, 1 or 3 on various failures)
451         (getent services "$service" || if [ "$?" -eq 2 ] ; then true ; else false; fi) | awk '{ print $2 }' | cut -f1 -d/ | sort -u
452     elif [ -r /etc/services ] ; then
453         # fall back to /etc/services for systems that don't have getent (MacOS?)
454         # FIXME: doesn't handle aliases like "null" (or "http"?), which don't show up at the beginning of the line.
455         awk $(printf '/^%s[[:space:]]/{ print $2 }' "$1") /etc/services | cut -f1 -d/ | sort -u
456     else
457         return 1
458     fi
459 }
460
461 # return the path to the home directory of a user
462 get_homedir() {
463     local uname=${1:-`whoami`}
464     eval "echo ~${uname}"
465 }
466
467 # return the primary group of a user
468 get_primary_group() {
469     local uname=${1:-`whoami`}
470     groups "$uname" | sed 's/^..* : //' | awk '{ print $1 }'
471 }
472
473 ### CONVERSION UTILITIES
474
475 # output the ssh key for a given key ID
476 gpg2ssh() {
477     local keyID
478     
479     keyID="$1"
480
481     gpg --export --no-armor "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
482 }
483
484 # output known_hosts line from ssh key
485 ssh2known_hosts() {
486     local host
487     local port
488     local key
489
490     # FIXME this does not properly deal with IPv6 hosts using the
491     # standard port (because it's unclear whether their final
492     # colon-delimited address section is a port number or an address
493     # string)
494     host=${1%:*}
495     port=${1##*:}
496     key="$2"
497
498     # specify the host and port properly for new ssh known_hosts
499     # format
500     if [ "$port" != "$host" ] ; then
501         host="[${host}]:${port}"
502     fi
503     printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
504 }
505
506 # output authorized_keys line from ssh key
507 ssh2authorized_keys() {
508     local userID
509     local key
510     
511     userID="$1"
512     key="$2"
513
514     printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
515 }
516
517 # convert key from gpg to ssh known_hosts format
518 gpg2known_hosts() {
519     local host
520     local keyID
521     local key
522
523     host="$1"
524     keyID="$2"
525
526     key=$(gpg2ssh "$keyID")
527
528     # NOTE: it seems that ssh-keygen -R removes all comment fields from
529     # all lines in the known_hosts file.  why?
530     # NOTE: just in case, the COMMENT can be matched with the
531     # following regexp:
532     # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
533     printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
534 }
535
536 # convert key from gpg to ssh authorized_keys format
537 gpg2authorized_keys() {
538     local userID
539     local keyID
540     local key
541
542     userID="$1"
543     keyID="$2"
544
545     key=$(gpg2ssh "$keyID")
546
547     # NOTE: just in case, the COMMENT can be matched with the
548     # following regexp:
549     # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
550     printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
551 }
552
553 ### GPG UTILITIES
554
555 # script to determine if gpg version is equal to or greater than specified version
556 is_gpg_version_greater_equal() {
557     local gpgVersion=$(gpg --version | head -1 | awk '{ print $3 }')
558     local latest=$(printf '%s\n%s\n' "$1" "$gpgVersion" \
559         | tr '.' ' ' | sort -g -k1 -k2 -k3 \
560         | tail -1 | tr ' ' '.')
561     [[ "$gpgVersion" == "$latest" ]]
562 }
563
564 # retrieve all keys with given user id from keyserver
565 # FIXME: need to figure out how to retrieve all matching keys
566 # (not just first N (5 in this case))
567 gpg_fetch_userid() {
568     local returnCode=0
569     local userID
570
571     if [ "$CHECK_KEYSERVER" != 'true' ] ; then
572         return 0
573     fi
574
575     userID="$1"
576
577     log verbose " checking keyserver $KEYSERVER... "
578     echo 1,2,3,4,5 | \
579         gpg --quiet --batch --with-colons \
580         --command-fd 0 --keyserver "$KEYSERVER" \
581         --search ="$userID" &>/dev/null
582     returnCode="$?"
583
584     if [ "$returnCode" != 0 ] ; then
585         log error "Failure ($returnCode) searching keyserver $KEYSERVER for user id '$userID'"
586     fi
587
588     return "$returnCode"
589 }
590
591 ########################################################################
592 ### PROCESSING FUNCTIONS
593
594 # userid and key policy checking
595 # the following checks policy on the returned keys
596 # - checks that full key has appropriate valididy (u|f)
597 # - checks key has specified capability (REQUIRED_KEY_CAPABILITY)
598 # - checks that requested user ID has appropriate validity
599 # (see /usr/share/doc/gnupg/DETAILS.gz)
600 # output is one line for every found key, in the following format:
601 #
602 # flag:sshKey
603 #
604 # "flag" is an acceptability flag, 0 = ok, 1 = bad
605 # "sshKey" is the translated gpg key
606 #
607 # all log output must go to stderr, as stdout is used to pass the
608 # flag:sshKey to the calling function.
609 process_user_id() {
610     local returnCode=0
611     local userID
612     local requiredCapability
613     local requiredPubCapability
614     local gpgOut
615     local type
616     local validity
617     local keyid
618     local uidfpr
619     local usage
620     local keyOK
621     local uidOK
622     local lastKey
623     local lastKeyOK
624     local fingerprint
625
626     userID="$1"
627
628     # set the required key capability based on the mode
629     requiredCapability=${REQUIRED_KEY_CAPABILITY:="a"}
630     requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
631
632     # fetch the user ID if necessary/requested
633     gpg_fetch_userid "$userID"
634
635     # output gpg info for (exact) userid and store
636     gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
637         --with-fingerprint --with-fingerprint \
638         ="$userID" 2>/dev/null) || returnCode="$?"
639
640     # if the gpg query return code is not 0, return 1
641     if [ "$returnCode" -ne 0 ] ; then
642         log verbose " no primary keys found."
643         return 1
644     fi
645
646     # loop over all lines in the gpg output and process.
647     echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
648     while IFS=: read -r type validity keyid uidfpr usage ; do
649         # process based on record type
650         case $type in
651             'pub') # primary keys
652                 # new key, wipe the slate
653                 keyOK=
654                 uidOK=
655                 lastKey=pub
656                 lastKeyOK=
657                 fingerprint=
658
659                 log verbose " primary key found: $keyid"
660
661                 # if overall key is not valid, skip
662                 if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
663                     log debug "  - unacceptable primary key validity ($validity)."
664                     continue
665                 fi
666                 # if overall key is disabled, skip
667                 if check_capability "$usage" 'D' ; then
668                     log debug "  - key disabled."
669                     continue
670                 fi
671                 # if overall key capability is not ok, skip
672                 if ! check_capability "$usage" $requiredPubCapability ; then
673                     log debug "  - unacceptable primary key capability ($usage)."
674                     continue
675                 fi
676
677                 # mark overall key as ok
678                 keyOK=true
679
680                 # mark primary key as ok if capability is ok
681                 if check_capability "$usage" $requiredCapability ; then
682                     lastKeyOK=true
683                 fi
684                 ;;
685             'uid') # user ids
686                 if [ "$lastKey" != pub ] ; then
687                     log verbose " ! got a user ID after a sub key?!  user IDs should only follow primary keys!"
688                     continue
689                 fi
690                 # if an acceptable user ID was already found, skip
691                 if [ "$uidOK" = 'true' ] ; then
692                     continue
693                 fi
694                 # if the user ID does matches...
695                 if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
696                     # and the user ID validity is ok
697                     if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
698                         # mark user ID acceptable
699                         uidOK=true
700                     else
701                         log debug "  - unacceptable user ID validity ($validity)."
702                     fi
703                 else
704                     continue
705                 fi
706
707                 # output a line for the primary key
708                 # 0 = ok, 1 = bad
709                 if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
710                     log verbose "  * acceptable primary key."
711                     if [ -z "$sshKey" ] ; then
712                         log error "    ! primary key could not be translated (not RSA?)."
713                     else
714                         echo "0:${sshKey}"
715                     fi
716                 else
717                     log debug "  - unacceptable primary key."
718                     if [ -z "$sshKey" ] ; then
719                         log debug "    ! primary key could not be translated (not RSA?)."
720                     else
721                         echo "1:${sshKey}"
722                     fi
723                 fi
724                 ;;
725             'sub') # sub keys
726                 # unset acceptability of last key
727                 lastKey=sub
728                 lastKeyOK=
729                 fingerprint=
730                 
731                 # don't bother with sub keys if the primary key is not valid
732                 if [ "$keyOK" != true ] ; then
733                     continue
734                 fi
735
736                 # don't bother with sub keys if no user ID is acceptable:
737                 if [ "$uidOK" != true ] ; then
738                     continue
739                 fi
740                 
741                 # if sub key validity is not ok, skip
742                 if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
743                     log debug "  - unacceptable sub key validity ($validity)."
744                     continue
745                 fi
746                 # if sub key capability is not ok, skip
747                 if ! check_capability "$usage" $requiredCapability ; then
748                     log debug "  - unacceptable sub key capability ($usage)."
749                     continue
750                 fi
751
752                 # mark sub key as ok
753                 lastKeyOK=true
754                 ;;
755             'fpr') # key fingerprint
756                 fingerprint="$uidfpr"
757
758                 sshKey=$(gpg2ssh "$fingerprint")
759
760                 # if the last key was the pub key, skip
761                 if [ "$lastKey" = pub ] ; then
762                     continue
763                 fi
764
765                 # output a line for the sub key
766                 # 0 = ok, 1 = bad
767                 if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
768                     log verbose "  * acceptable sub key."
769                     if [ -z "$sshKey" ] ; then
770                         log error "    ! sub key could not be translated (not RSA?)."
771                     else
772                         echo "0:${sshKey}"
773                     fi
774                 else
775                     log debug "  - unacceptable sub key."
776                     if [ -z "$sshKey" ] ; then
777                         log debug "    ! sub key could not be translated (not RSA?)."
778                     else
779                         echo "1:${sshKey}"
780                     fi
781                 fi
782                 ;;
783         esac
784     done | sort -t: -k1 -n -r
785     # NOTE: this last sort is important so that the "good" keys (key
786     # flag '0') come last.  This is so that they take precedence when
787     # being processed in the key files over "bad" keys (key flag '1')
788 }
789
790 # output all valid keys for specified user ID literal
791 keys_for_userid() {
792     local userID
793     local noKey=
794     local nKeys
795     local nKeysOK
796     local ok
797     local sshKey
798     local tmpfile
799
800     userID="$1"
801
802     log verbose "processing: $userID"
803
804     nKeys=0
805     nKeysOK=0
806
807     IFS=$'\n'
808     for line in $(process_user_id "${userID}") ; do
809         # note that key was found
810         nKeys=$((nKeys+1))
811
812         ok=$(echo "$line" | cut -d: -f1)
813         sshKey=$(echo "$line" | cut -d: -f2)
814
815         if [ -z "$sshKey" ] ; then
816             continue
817         fi
818
819         # if key OK, output key to stdout
820         if [ "$ok" -eq '0' ] ; then
821             # note that key was found ok
822             nKeysOK=$((nKeysOK+1))
823
824             printf '%s\n' "$sshKey"
825         fi
826     done
827
828     # if at least one key was found...
829     if [ "$nKeys" -gt 0 ] ; then
830         # if ok keys were found, return 0
831         if [ "$nKeysOK" -gt 0 ] ; then
832             return 0
833         # else return 2
834         else
835             return 2
836         fi
837     # if no keys were found, return 1
838     else
839         return 1
840     fi
841 }
842
843 # process a single host in the known_host file
844 process_host_known_hosts() {
845     local host
846     local userID
847     local noKey=
848     local nKeys
849     local nKeysOK
850     local ok
851     local sshKey
852     local tmpfile
853
854     # set the key processing mode
855     export REQUIRED_KEY_CAPABILITY="$REQUIRED_HOST_KEY_CAPABILITY"
856
857     host="$1"
858     userID="ssh://${host}"
859
860     log verbose "processing: $host"
861
862     nKeys=0
863     nKeysOK=0
864
865     IFS=$'\n'
866     for line in $(process_user_id "${userID}") ; do
867         # note that key was found
868         nKeys=$((nKeys+1))
869
870         ok=$(echo "$line" | cut -d: -f1)
871         sshKey=$(echo "$line" | cut -d: -f2)
872
873         if [ -z "$sshKey" ] ; then
874             continue
875         fi
876
877         # remove any old host key line, and note if removed nothing is
878         # removed
879         remove_line "$KNOWN_HOSTS" "$sshKey" || noKey=true
880
881         # if key OK, add new host line
882         if [ "$ok" -eq '0' ] ; then
883             # note that key was found ok
884             nKeysOK=$((nKeysOK+1))
885
886             # hash if specified
887             if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
888                 # FIXME: this is really hackish cause ssh-keygen won't
889                 # hash from stdin to stdout
890                 tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
891                 ssh2known_hosts "$host" "$sshKey" > "$tmpfile"
892                 ssh-keygen -H -f "$tmpfile" 2>/dev/null
893                 cat "$tmpfile" >> "$KNOWN_HOSTS"
894                 rm -f "$tmpfile" "${tmpfile}.old"
895             else
896                 ssh2known_hosts "$host" "$sshKey" >> "$KNOWN_HOSTS"
897             fi
898
899             # log if this is a new key to the known_hosts file
900             if [ "$noKey" ] ; then
901                 log info "* new key for $host added to known_hosts file."
902             fi
903         fi
904     done
905
906     # if at least one key was found...
907     if [ "$nKeys" -gt 0 ] ; then
908         # if ok keys were found, return 0
909         if [ "$nKeysOK" -gt 0 ] ; then
910             return 0
911         # else return 2
912         else
913             return 2
914         fi
915     # if no keys were found, return 1
916     else
917         return 1
918     fi
919 }
920
921 # update the known_hosts file for a set of hosts listed on command
922 # line
923 update_known_hosts() {
924     local returnCode=0
925     local nHosts
926     local nHostsOK
927     local nHostsBAD
928     local fileCheck
929     local host
930     local newUmask
931
932     # the number of hosts specified on command line
933     nHosts="$#"
934
935     nHostsOK=0
936     nHostsBAD=0
937
938     # touch the known_hosts file so that the file permission check
939     # below won't fail upon not finding the file
940     if [ ! -f "$KNOWN_HOSTS" ]; then
941         # make sure to create any files or directories with the appropriate write bits turned off:
942         newUmask=$(printf "%04o" $(( 0$(umask) | 0022 )) )
943         [ -d $(dirname "$KNOWN_HOSTS") ] \
944             || (umask "$newUmask" && mkdir -p -m 0700 $(dirname "$KNOWN_HOSTS") ) \
945             || failure "Could not create path to known_hosts file '$KNOWN_HOSTS'"
946         # make sure to create this file with the appropriate bits turned off:
947         (umask "$newUmask" && touch "$KNOWN_HOSTS") \
948             || failure "Unable to create known_hosts file '$KNOWN_HOSTS'"
949     fi
950
951     # check permissions on the known_hosts file path
952     check_key_file_permissions $(whoami) "$KNOWN_HOSTS" \
953         || failure "Bad permissions governing known_hosts file '$KNOWN_HOSTS'"
954
955     # create a lockfile on known_hosts:
956     lock create "$KNOWN_HOSTS"
957     # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
958     trap "lock remove $KNOWN_HOSTS" EXIT
959
960     # note pre update file checksum
961     fileCheck=$(file_hash "$KNOWN_HOSTS")
962
963     for host ; do
964         # process the host
965         process_host_known_hosts "$host" || returnCode="$?"
966         # note the result
967         case "$returnCode" in
968             0)
969                 nHostsOK=$((nHostsOK+1))
970                 ;;
971             2)
972                 nHostsBAD=$((nHostsBAD+1))
973                 ;;
974         esac
975
976         # touch the lockfile, for good measure.
977         lock touch "$KNOWN_HOSTS"
978     done
979
980     # remove the lockfile and the trap
981     lock remove "$KNOWN_HOSTS"
982     trap - EXIT
983
984     # note if the known_hosts file was updated
985     if [ "$(file_hash "$KNOWN_HOSTS")" != "$fileCheck" ] ; then
986         log debug "known_hosts file updated."
987     fi
988
989     # if an acceptable host was found, return 0
990     if [ "$nHostsOK" -gt 0 ] ; then
991         return 0
992     # else if no ok hosts were found...
993     else
994         # if no bad host were found then no hosts were found at all,
995         # and return 1
996         if [ "$nHostsBAD" -eq 0 ] ; then
997             return 1
998         # else if at least one bad host was found, return 2
999         else
1000             return 2
1001         fi
1002     fi
1003 }
1004
1005 # process hosts from a known_hosts file
1006 process_known_hosts() {
1007     local hosts
1008
1009     # exit if the known_hosts file does not exist
1010     if [ ! -e "$KNOWN_HOSTS" ] ; then
1011         failure "known_hosts file '$KNOWN_HOSTS' does not exist."
1012     fi
1013
1014     log debug "processing known_hosts file:"
1015     log debug " $KNOWN_HOSTS"
1016
1017     hosts=$(meat "$KNOWN_HOSTS" | cut -d ' ' -f 1 | grep -v '^|.*$' | tr , ' ' | tr '\n' ' ')
1018
1019     if [ -z "$hosts" ] ; then
1020         log debug "no hosts to process."
1021         return
1022     fi
1023
1024     # take all the hosts from the known_hosts file (first
1025     # field), grep out all the hashed hosts (lines starting
1026     # with '|')...
1027     update_known_hosts $hosts
1028 }
1029
1030 # process uids for the authorized_keys file
1031 process_uid_authorized_keys() {
1032     local userID
1033     local nKeys
1034     local nKeysOK
1035     local ok
1036     local sshKey
1037
1038     # set the key processing mode
1039     export REQUIRED_KEY_CAPABILITY="$REQUIRED_USER_KEY_CAPABILITY"
1040
1041     userID="$1"
1042
1043     log verbose "processing: $userID"
1044
1045     nKeys=0
1046     nKeysOK=0
1047
1048     IFS=$'\n'
1049     for line in $(process_user_id "$userID") ; do
1050         # note that key was found
1051         nKeys=$((nKeys+1))
1052
1053         ok=$(echo "$line" | cut -d: -f1)
1054         sshKey=$(echo "$line" | cut -d: -f2)
1055
1056         if [ -z "$sshKey" ] ; then
1057             continue
1058         fi
1059
1060         # remove the old host key line
1061         remove_line "$AUTHORIZED_KEYS" "$sshKey"
1062
1063         # if key OK, add new host line
1064         if [ "$ok" -eq '0' ] ; then
1065             # note that key was found ok
1066             nKeysOK=$((nKeysOK+1))
1067
1068             ssh2authorized_keys "$userID" "$sshKey" >> "$AUTHORIZED_KEYS"
1069         fi
1070     done
1071
1072     # if at least one key was found...
1073     if [ "$nKeys" -gt 0 ] ; then
1074         # if ok keys were found, return 0
1075         if [ "$nKeysOK" -gt 0 ] ; then
1076             return 0
1077         # else return 2
1078         else
1079             return 2
1080         fi
1081     # if no keys were found, return 1
1082     else
1083         return 1
1084     fi
1085 }
1086
1087 # update the authorized_keys files from a list of user IDs on command
1088 # line
1089 update_authorized_keys() {
1090     local returnCode=0
1091     local userID
1092     local nIDs
1093     local nIDsOK
1094     local nIDsBAD
1095     local fileCheck
1096
1097     # the number of ids specified on command line
1098     nIDs="$#"
1099
1100     nIDsOK=0
1101     nIDsBAD=0
1102
1103     log debug "updating authorized_keys file:"
1104     log debug " $AUTHORIZED_KEYS"
1105
1106     # check permissions on the authorized_keys file path
1107     check_key_file_permissions $(whoami) "$AUTHORIZED_KEYS" || failure
1108
1109     # create a lockfile on authorized_keys
1110     lock create "$AUTHORIZED_KEYS"
1111     # FIXME: we're discarding any pre-existing EXIT trap; is this bad?
1112     trap "lock remove $AUTHORIZED_KEYS" EXIT
1113
1114     # note pre update file checksum
1115     fileCheck="$(file_hash "$AUTHORIZED_KEYS")"
1116
1117     # remove any monkeysphere lines from authorized_keys file
1118     remove_monkeysphere_lines "$AUTHORIZED_KEYS"
1119
1120     for userID ; do
1121         # process the user ID, change return code if key not found for
1122         # user ID
1123         process_uid_authorized_keys "$userID" || returnCode="$?"
1124
1125         # note the result
1126         case "$returnCode" in
1127             0)
1128                 nIDsOK=$((nIDsOK+1))
1129                 ;;
1130             2)
1131                 nIDsBAD=$((nIDsBAD+1))
1132                 ;;
1133         esac
1134
1135         # touch the lockfile, for good measure.
1136         lock touch "$AUTHORIZED_KEYS"
1137     done
1138
1139     # remove the lockfile and the trap
1140     lock remove "$AUTHORIZED_KEYS"
1141
1142     # remove the trap
1143     trap - EXIT
1144
1145     # note if the authorized_keys file was updated
1146     if [ "$(file_hash "$AUTHORIZED_KEYS")" != "$fileCheck" ] ; then
1147         log debug "authorized_keys file updated."
1148     fi
1149
1150     # if an acceptable id was found, return 0
1151     if [ "$nIDsOK" -gt 0 ] ; then
1152         return 0
1153     # else if no ok ids were found...
1154     else
1155         # if no bad ids were found then no ids were found at all, and
1156         # return 1
1157         if [ "$nIDsBAD" -eq 0 ] ; then
1158             return 1
1159         # else if at least one bad id was found, return 2
1160         else
1161             return 2
1162         fi
1163     fi
1164 }
1165
1166 # process an authorized_user_ids file for authorized_keys
1167 process_authorized_user_ids() {
1168     local line
1169     local nline
1170     local userIDs
1171
1172     authorizedUserIDs="$1"
1173
1174     # exit if the authorized_user_ids file is empty
1175     if [ ! -e "$authorizedUserIDs" ] ; then
1176         failure "authorized_user_ids file '$authorizedUserIDs' does not exist."
1177     fi
1178
1179     log debug "processing authorized_user_ids file:"
1180     log debug " $authorizedUserIDs"
1181
1182     # check permissions on the authorized_user_ids file path
1183     check_key_file_permissions $(whoami) "$authorizedUserIDs" || failure
1184
1185     if ! meat "$authorizedUserIDs" >/dev/null ; then
1186         log debug " no user IDs to process."
1187         return
1188     fi
1189
1190     nline=0
1191
1192     # extract user IDs from authorized_user_ids file
1193     IFS=$'\n'
1194     for line in $(meat "$authorizedUserIDs") ; do
1195         userIDs["$nline"]="$line"
1196         nline=$((nline+1))
1197     done
1198
1199     update_authorized_keys "${userIDs[@]}"
1200 }
1201
1202 # takes a gpg key or keys on stdin, and outputs a list of
1203 # fingerprints, one per line:
1204 list_primary_fingerprints() {
1205     local fake=$(msmktempdir)
1206     trap "rm -rf $fake" EXIT
1207     GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
1208     GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
1209         awk -F: '/^fpr:/{ print $10 }'
1210     trap - EXIT
1211     rm -rf "$fake"
1212 }
1213
1214 # takes an OpenPGP key or set of keys on stdin, a fingerprint or other
1215 # key identifier as $1, and outputs the gpg-formatted information for
1216 # the requested keys from the material on stdin
1217 get_cert_info() {
1218     local fake=$(msmktempdir)
1219     trap "rm -rf $fake" EXIT
1220     GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
1221     GNUPGHOME="$fake" gpg --with-colons --fingerprint --fixed-list-mode --list-keys "$1"
1222     trap - EXIT
1223     rm -rf "$fake"
1224 }
1225
1226
1227 check_cruft_file() {
1228     local loc="$1"
1229     local version="$2"
1230     
1231     if [ -e "$loc" ] ; then
1232         printf "! The file '%s' is no longer used by\n  monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
1233     fi
1234 }
1235
1236 check_upgrade_dir() {
1237     local loc="$1"
1238     local version="$2"
1239
1240     if [ -d "$loc" ] ; then
1241         printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n  %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
1242     fi
1243 }
1244
1245 ## look for cruft from old versions of the monkeysphere, and notice if
1246 ## upgrades have not been run:
1247 report_cruft() {
1248     check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
1249     check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
1250
1251     check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
1252     check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
1253
1254     local found=
1255     for foo in "${SYSDATADIR}/backup-from-"*"-transition"  ; do
1256         if [ -d "$foo" ] ; then
1257             printf "! %s\n" "$foo" | log info
1258             found=true
1259         fi
1260     done
1261     if [ "$found" ] ; then
1262         printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
1263     fi
1264 }